
var HARDWARE = 0;
var OPSYS = 1;
var IAPPS = 2;

function WMIClass(sec,desc)
{
    this.sid = sec;
    this.section = desc;
    this.classes = new Array(arguments.length-2);
    for (var i=2; i<arguments.length; i++) {
        this.classes[i-2] = arguments[i];
    }
}
function _classTable(el)
{
    var MAX_COLUMNS = 4;
    var i;
    var count = 0;
    var a;
    var s = '<table cellspacing="1" cellpadding="1" width="100%" bgcolor="black">';
    for (i=0; i<this.classes.length; i++) {
        if (count == 0) {
            s += '<tr>';
        }
        a = '<a class="wmiClass" href="javascript:WMIAll(\'' + this.classes[i] + '\',\'' + el + '\');">';
        s += '<td class="wmiClass" width="' + (300/MAX_COLUMNS) + '%">' + a + this.classes[i] + '</a></td>';
        count++;
        if (count == MAX_COLUMNS) {
            s += '</tr>';
            count = 0;
        }
    }
    if (count!=0) {
        for (i=0; i<MAX_COLUMNS-count; i++) s += '<td class="wmiClass">&nbsp;</td>';
        s += '</tr>';
    }
    s += '</table>';
    return s;
}
WMIClass.prototype.classTable = _classTable;

var wmiClasses = new Array(
    new WMIClass(
        HARDWARE,
        "Cooling Device Classes",
            "Win32_Fan",
            "Win32_HeatPipe",
            "Win32_Refrigeration", 
            "Win32_TemperatureProbe"),
    new WMIClass(
        HARDWARE,
        "Input Device Classes",
            "Win32_Keyboard",
            "Win32_PointingDevice"),
    new WMIClass(
        HARDWARE,
        "Mass Storage Classes",
            "Win32_CDROMDrive",
            "Win32_DiskDrive",
            "Win32_FloppyDrive",
            "Win32_LogicalDisk",
            "Win32_TapeDrive"),
    new WMIClass(
        HARDWARE,
        "Motherboard, Controller, and Port Classes",
            "Win32_1394Controller",
            "Win32_1394ControllerDevice",
            "Win32_AllocatedResource",
            "Win32_AssociatedProcessorMemory",
            "Win32_BaseBoard",  
            "Win32_BIOS",
            "Win32_Bus",
            "Win32_CacheMemory",
            "Win32_DeviceBus",
            "Win32_DeviceMemoryAddress",
            "Win32_DeviceSettings",
            "Win32_DMAChannel",
            "Win32_FloppyController",
            "Win32_IDEController",
            "Win32_IDEControllerDevice",
            "Win32_InfraredDevice",
            "Win32_IRQResource",
            "Win32_MemoryArray",
            "Win32_MemoryArrayLocation",
            "Win32_MemoryDevice",
            "Win32_MemoryDeviceArray",
            "Win32_MemoryDeviceLocation",
            "Win32_MotherboardDevice",
            "Win32_OnBoardDevice",
            "Win32_ParallelPort",
            "Win32_PCMCIAController",
            "Win32_PhysicalMemory",
            "Win32_PhysicalMemoryArray",
            "Win32_PhysicalMemoryLocation",
            "Win32_PnPAllocatedResource",
            "Win32_PnPDevice",
            "Win32_PnPEntity",
            "Win32_PortConnector",
            "Win32_PortResource",
            "Win32_Processor",
            "Win32_SCSIController",
            "Win32_SCSIControllerDevice",
            "Win32_SerialPort",
            "Win32_SerialPortConfiguration",
            "Win32_SerialPortSetting",
            "Win32_SMBIOSMemory",
            "Win32_SoundDevice",
            "Win32_SystemBIOS",
            "Win32_SystemDriverPNPEntity",
            "Win32_SystemEnclosure",
            "Win32_SystemMemoryResource",
            "Win32_SystemSlot",
            "Win32_USBController", 
            "Win32_USBControllerDevice"),  
    new WMIClass(
        HARDWARE,
        "Networking Device Classes",
            "Win32_NetworkAdapter",
            "Win32_NetworkAdapterConfiguration",
            "Win32_NetworkAdapterSetting"),
    new WMIClass(
        HARDWARE,
        "Power Classes",
            "Win32_AssociatedBattery",
            "Win32_Battery",
            "Win32_CurrentProbe",
            "Win32_PortableBattery",
            "Win32_PowerManagementEvent",
            "Win32_UninterruptiblePowerSupply",
            "Win32_VoltageProbe"),  
    new WMIClass(
        HARDWARE,
        "Printing Classes",
            "Win32_Printer",
            "Win32_PrinterConfiguration",
            "Win32_PrinterController",
            "Win32_PrinterDriverDll",
            "Win32_PrinterSetting",
            "Win32_PrintJob"), 
    new WMIClass(
        HARDWARE,
        "Telephony Classes",
            "Win32_POTSModem",
            "Win32_POTSModemToSerialPort"),
    new WMIClass(
        HARDWARE,
        "Video and Monitor Classes",
            "Win32_DesktopMonitor",
            "Win32_DisplayConfiguration",
            "Win32_DisplayControllerConfiguration",
            "Win32_VideoConfiguration",
            "Win32_VideoController",
            "Win32_VideoSettings"),
    new WMIClass(
        OPSYS,            
        "COM/DCOM",
            "Win32_ClassicCOMApplicationClasses",
            "Win32_ClassicCOMClass",
            "Win32_ClassicCOMClassSettings",
            "Win32_ClientApplicationSetting",
            "Win32_COMApplication",
            "Win32_COMApplicationClasses",
            "Win32_COMApplicationSettings",
            "Win32_COMClass",
            "Win32_ComClassAutoEmulator",
            "Win32_ComClassEmulator",
            "Win32_ComponentCategory",
            "Win32_COMSetting",
            "Win32_DCOMApplication",
            "Win32_DCOMApplicationAccessAllowedSetting",
            "Win32_DCOMApplicationLaunchAllowedSetting",
            "Win32_DCOMApplicationSetting",
            "Win32_ImplementedCategory"),
    new WMIClass(            
        OPSYS,
        "Desktop",
            "Win32_Desktop",
            "Win32_Environment",
            "Win32_TimeZone",
            "Win32_UserDesktop"),
    new WMIClass(            
        OPSYS,
        "Drivers",
            "Win32_DriverVXD",
            "Win32_SystemDriver"),
    new WMIClass(            
        OPSYS,
        "File System",
            "Win32_CIMLogicalDeviceCIMDataFile",
            "Win32_Directory",
            "Win32_DirectorySpecification",
            "Win32_DiskDriveToDiskPartition",
            "Win32_DiskPartition",
            "Win32_LogicalDiskRootDirectory",
            "Win32_LogicalDiskToPartition",
            "Win32_ShortcutFile",
            "Win32_SubDirectory",
            "Win32_SystemPartitions"),
    new WMIClass(            
        OPSYS,
        "Memory and Page Files",
            "Win32_LogicalMemoryConfiguration",
            "Win32_PageFile",
            "Win32_PageFileElementSetting",
            "Win32_PageFileSetting",
            "Win32_PageFileUsage",
            "Win32_SystemLogicalMemoryConfiguration"),
    new WMIClass(            
        OPSYS,
        "Multimedia Audio/Visual",
            "Win32_CodecFile"),
    new WMIClass(            
        OPSYS,
        "Networking Classes",
            "Win32_NetworkClient",
            "Win32_NetworkConnection",
            "Win32_NetworkProtocol",
            "Win32_ProtocolBinding"),
    new WMIClass(            
        OPSYS,
        "Operating System Settings",
            "Win32_BootConfiguration",
            "Win32_ComputerSystem",
            "Win32_ComputerSystemProcessor",
            "Win32_ComputerSystemProduct",
            "Win32_DependentService",
            "Win32_LoadOrderGroup",
            "Win32_LoadOrderGroupServiceDependencies",
            "Win32_LoadOrderGroupServiceMembers",
            "Win32_OperatingSystem",
            "Win32_OperatingSystemQFE",
            "Win32_OSRecoveryConfiguration",
            "Win32_QuickFixEngineering",
            "Win32_StartupCommand",
            "Win32_SystemBootConfiguration",
            "Win32_SystemDesktop",
            "Win32_SystemDevices",
            "Win32_SystemLoadOrderGroups",
            "Win32_SystemNetworkConnections",
            "Win32_SystemOperatingSystem",
            "Win32_SystemProcesses",
            "Win32_SystemProgramGroups",
            "Win32_SystemResources",
            "Win32_SystemServices",
            "Win32_SystemSetting",
            "Win32_SystemSystemDriver",
            "Win32_SystemTimeZone",
            "Win32_SystemUsers"),
    new WMIClass(            
        OPSYS,
        "Processes",
            "Win32_Process",
            "Win32_ProcessStartup",
            "Win32_Thread"),
    new WMIClass(            
        OPSYS,
        "Registry",
            "Win32_Registry"),
    new WMIClass(            
        OPSYS,
        "Scheduler Jobs",
            "Win32_ScheduledJob"),
    new WMIClass(
        OPSYS,
        "Security",
            "Win32_AccountSID",
            "Win32_ACE",
            "Win32_LogicalFileAccess",
            "Win32_LogicalFileAuditing", 
            "Win32_LogicalFileGroup",
            "Win32_LogicalFileOwner",
            "Win32_LogicalFileSecuritySetting",
            "Win32_LogicalShareAccess",
            "Win32_LogicalShareAuditing",
            "Win32_LogicalShareSecuritySetting",
            "Win32_PrivilegesStatus",
            "Win32_SecurityDescriptor",
            "Win32_SecuritySetting",
            "Win32_SecuritySettingAccess",
            "Win32_SecuritySettingAuditing",
            "Win32_SecuritySettingGroup",
            "Win32_SecuritySettingOfLogicalFile",
            "Win32_SecuritySettingOfLogicalShare",
            "Win32_SecuritySettingOfObject",
            "Win32_SecuritySettingOwner",
            "Win32_SID",
            "Win32_Trustee"), 
    new WMIClass(
        OPSYS,
        "Services",
            "Win32_BaseService",
            "Win32_Service"),
    new WMIClass(
        OPSYS,
        "Shares",
            "Win32_PrinterShare",
            "Win32_Share",
            "Win32_ShareToDirectory"),
    new WMIClass(
        OPSYS,
        "Start Menu",
            "Win32_LogicalProgramGroup",
            "Win32_LogicalProgramGroupDirectory",
            "Win32_LogicalProgramGroupItem",
            "Win32_LogicalProgramGroupItemDataFile",
            "Win32_ProgramGroup",
            "Win32_ProgramGroupContents",
            "Win32_ProgramGroupOrItem"),
    new WMIClass(
        OPSYS,
        "Users",
            "Win32_Account",
            "Win32_Group",
            "Win32_GroupUser",
            "Win32_NetworkLoginProfile",
            "Win32_SystemAccount",
            "Win32_UserAccount"),
    new WMIClass(
        OPSYS,
        "Windows NT Event Log",
            "Win32_NTEventlogFile",
            "Win32_NTLogEvent",
            "Win32_NTLogEventComputer",
            "Win32_NTLogEventLog",
            "Win32_NTLogEventUser"), 
    new WMIClass(
        IAPPS,
        "Installed Applications Classes",
            "Win32_ActionCheck",
            "Win32_ApplicationCommandLine",
            "Win32_ApplicationService",
            "Win32_Binary",
            "Win32_BindImageAction",
            "Win32_CheckCheck",
            "Win32_ClassInfoAction",
            "Win32_CommandLineAccess",
            "Win32_Condition",
            "Win32_CreateFolderAction",
            "Win32_DuplicateFileAction",
            "Win32_EnvironmentSpecification",
            "Win32_ExtensionInfoAction",
            "Win32_FileSpecification",
            "Win32_FontInfoAction",
            "Win32_IniFileSpecification",
            "Win32_InstalledSoftwareElement",
            "Win32_LaunchCondition",
            "Win32_ManagedSystemElementResource",
            "Win32_MIMEInfoAction",
            "Win32_MoveFileAction",
            "Win32_MSIResource",
            "Win32_ODBCAttribute",
            "Win32_ODBCDataSourceAttribute",
            "Win32_ODBCDataSourceSpecification",
            "Win32_ODBCDriverAttribute",
            "Win32_ODBCDriverSoftwareElement",
            "Win32_ODBCDriverSpecification",
            "Win32_ODBCSourceAttribute",
            "Win32_ODBCTranslatorSpecification",
            "Win32_Patch",
            "Win32_PatchFile",
            "Win32_PatchPackage",
            "Win32_Product",
            "Win32_ProductCheck",
            "Win32_ProductResource",
            "Win32_ProductSoftwareFeatures",
            "Win32_ProgIDSpecification",
            "Win32_Property",
            "Win32_PublishComponentAction",
            "Win32_RegistryAction",
            "Win32_RemoveFileAction",
            "Win32_RemoveIniAction",
            "Win32_ReserveCost",
            "Win32_SelfRegModuleAction",
            "Win32_ServiceControl",
            "Win32_ServiceSpecification",
            "Win32_ServiceSpecificationService",
            "Win32_SettingCheck",
            "Win32_ShortcutAction",
            "Win32_ShortcutSAP",
            "Win32_SoftwareElement",
            "Win32_SoftwareElementAction",
            "Win32_SoftwareElementCheck",
            "Win32_SoftwareElementCondition",
            "Win32_SoftwareElementResource",
            "Win32_SoftwareFeature",
            "Win32_SoftwareFeatureAction",
            "Win32_SoftwareFeatureCheck",
            "Win32_SoftwareFeatureParent",
            "Win32_SoftwareFeatureSoftwareElements",
            "Win32_TypeLibraryAction")
);
